""" ALP2-Team
    Solutions (4. Aufgabe des 4. Übungsblatt)
"""

from ps_functions import *                  

def MickeyMouseFractal(filename, size):     # size is the length of the square sides of a
                                            # bounding box with lower-left corner (0,0) and
                                            # upper-right corner (size, size) surrounding
                                            # our fractal image
    
    def paint_fractal(x,y,radius):          # (x,y) is the center of the circle to be paint
                                            # at the beginning of each recursive call
        if radius >= 1:                     # we stop the recursion, when radius smaller than 1
            fillCircle(x, y, radius)          
            paint_fractal(x-radius, y-radius, radius/2)
            paint_fractal(x-radius, y+radius, radius/2)
            paint_fractal(x+radius, y-radius, radius/2)
            paint_fractal(x+radius, y+radius, radius/2)


    begin(filename,size,size)               # write the head of the postscript file, set a bounding box
                                            # with corners (0,0) and (size,size) and open
                                            # a file-structure for the filename.
    paint_fractal(size/2, size/2, size/4)   # the first circle will be place in the middle of the
                                            # Bounding Box and the radius is 1/4 of the Bounding Box side
                                            
    end()                                   # close the file-structure and the filename


# test

MickeyMouseFractal("MM_fractal.ps",600)     # A file "MM_fractal.ps" will be created, if it doesn't exist.
                                            # A PostScript program, which paint the fractal, will be produce
                                            # and save in the file 
